#include "cvos.h"
#include "../resource/prog.h"

#define	ABOUT		"wikiZ 0.4 by Huidae Cho\rhttp://wikix.org"

#define	APPMAN_ID	1
#define	PHOTOALBUM_ID	0x504f544f
#define	CELART_ID	0x43656c61
#define	MEMOPLUS_ID	0x4d4d504c
#define	MYDAYS_ID	0x504c4e52

#define	mkinfo(msg)	MsgBoxDo(MK_INFORMATION, "Information!", msg, MSGBOX_OK)
#define	mkwarn(msg)	MsgBoxDo(MK_WARNING, "Warning!", msg, MSGBOX_OK)
#define	mkerror(msg)	MsgBoxDo(MK_ERROR, "Error!", msg, MSGBOX_OK)
#define	mkfatal(msg)	MsgBoxDo(MK_FATAL, "Fatal Error!", msg, MSGBOX_OK)

U8	*strstr(U8 *str, U8 *sub);
U8	*strchr(U8 *str, U8 chr);

STATUS	CommandProcessing(U32 cmd, P_U32 param);
Boolean	AppHandleEvent(EventStruct *e);
Boolean	MainFormHandleEvent(EventStruct *e);
Boolean	MyHackFunction(EventStruct *e, P_VOID pInfo);
Boolean	FindData(TableId tableId, FieldId fieldId, U8 *keyword, U8 mode,
		RecId *recId);
Boolean	GetKeyWord(U8 *buf, U8 *ptr, U8 **keyword, U8 *sep);
Boolean	ShortcutsFormHandleEvent(EventStruct *e);
DBoxDrawCallbackFuncPtr	DrawShortcutsForm(void);

U16	CurrFormID;
U32	AppID;
Boolean	Hack = FALSE;
Boolean	Shortcuts = TRUE;
U8	*Word;
int	WordLen;
S8	iLink;

CMDVIEWFINDSTR	Cvfs;

#define	MemoDB		0	// []
#define	AddressDB	1	// ()
#define	SchedNrDB	2	// <>
#define	SchedRpDB	3	// <>
#define	TodoDB		4	// `'
#define	InkDB		5	// {{}}
#define	PhotoAlbum	6	// {}

#define	nTables		7
#define	nAids		2
struct	linkInfo {
	U32	aid[nAids];	// AppId
	U8	ipw[nAids];	// Internal Password Support
	U8	aidx;		// AppId Index
	U8	*tname;		// TableName
	TableId	tid;		// TableId
	FieldId	fid;		// FieldId
	FieldId	tfid;		// Tap FieldId
	U8	sep;		// Separator
} Link[nTables] = {
	{	// Memo
		{FAH_BASEAPPID+FAH_MEMO, MEMOPLUS_ID}, {0, 1}, 0,
		"MemoDB", NULL_TABLE_ID, 0, 0, '['
	},
	{	// Address
		{FAH_BASEAPPID+FAH_ADDRESS, MYDAYS_ID}, {0, 1}, 0,
		"AddressDB", NULL_TABLE_ID, 0, 15, '('
	},
	{	// Scheduler
		{FAH_BASEAPPID+FAH_SCHEDULER, MYDAYS_ID}, {0, 1}, 0,
		"SchedNrDB", NULL_TABLE_ID, 0, 3, '<'
	},
	{	// Scheduler
		{FAH_BASEAPPID+FAH_SCHEDULER, MYDAYS_ID}, {0, 1}, 0,
		"SchedRpDB", NULL_TABLE_ID, 0, 3, '<'
	},
	{	// Todo
		{FAH_BASEAPPID+FAH_TODO, MYDAYS_ID}, {0, 1}, 0,
		"TodoDB", NULL_TABLE_ID, 3, 3, '`'
	},
	{	// InkWriter
		{FAH_BASEAPPID+FAH_INKWRITER, 0}, {0, 0}, 0,
		"InkDB", NULL_TABLE_ID, 1, NULL_FIELD_ID, '}'
	},
	{	// PhotoAlbum
		{PHOTOALBUM_ID, 0}, {0, 0}, 0,
		"PhotoAlbum", NULL_TABLE_ID, 0, 4, '{'
	},
};

#define	HINFOSIZE	256
S16	hDepth = -1;
struct	historyInfo {
	U32	aid;
	U8	ipw;
	TableId	tid;
	RecId	rid;
} hInfo[HINFOSIZE];

#define	nkbdIds		4
U32	kbdId[nkbdIds] = {
	0x4b424400,	// KBD
	0x4e4b4244,	// NKBD
	0x424b4241,	// BKBA
	0x43414a4b,	// CAJK
//	0x4d4d504c,	// MMPL
};

#define	TMPSIZE		128
char	tmp[TMPSIZE];

/*
typedef	struct {
	Boolean	TODO;
} MyHackInfo;
*/


STATUS
AppMain(U32 cmd, U32 *param)
{
	EventStruct	event;

	if(cmd != NORMAL_START)
		return CommandProcessing(cmd, param);

	if(!FormGo(Form_Form_1000))
		return CVOS_ERROR;

	do{
		while(!EventGet(&event));
		if(!SystemHandleEvent(&event))
			if(!MenuHandleEvent(&event))
				if(!AppHandleEvent(&event))
					FormDispatchEvent(&event);
	}while(event.EventType != APPSTOPEVENT);

	return CVOS_OK;
}

STATUS
CommandProcessing(U32 cmd, P_U32 param)
{
	STATUS	ret = CVOS_NOTHING;
	CVHACKINFO	cvhack;
	//MyHackInfo	HackInfo;
	int	i;
	U32	sysTool;

	switch(cmd){
	case REQ_INITDB:
		for(i=0; i<nTables; i++){
			if(DBMGetTableId(Link[i].tname, &(Link[i].tid))
					!= DBM_OK)
				Link[i].tid = NULL_TABLE_ID;
		}

		Hack = TRUE;
		cvhack.pHackName = (P_U8)"wikiZ";
		cvhack.pNote = (P_U8)"wikiZ";
		cvhack.InfoLen = 0;//sizeof(MyHackInfo);
		cvhack.pInfo = NULL;//(P_U8)&HackInfo;
		cvhack.AppID = AppID = GetCurAppID();
		cvhack.OpFlag = 3;
		cvhack.Fn = MyHackFunction;
		ret = SetCVHackFunction(&cvhack);
		break;
	case REQ_UNINSTALL:
		if(Hack){
			cvhack.Fn = MyHackFunction;
			GetCVHackInfo(&cvhack);
			RemoveCVHackFunction(&cvhack);
		}
		break;
	case REQ_USER_COMMAND:
		sysTool = GetSystemToolStatus();
		SystemToolDisable(ALLSYSTOOL_BITS);
		DBoxNew(Form_Form_1004);
		FormSetEventHandler(ShortcutsFormHandleEvent);
		DBoxSetDrawCallback((DBoxDrawCallbackFuncPtr)DrawShortcutsForm);
		DBoxDo(Form_Form_1004);
		FormFree();
		SystemToolEnable(sysTool);
		break;
	}

	return ret;
}

Boolean
AppHandleEvent(EventStruct *e)
{
	Boolean	ret = FALSE;
	ComponentStruct	*c;

	switch(e->EventType){
	case FORMLOADEVENT:
		CurrFormID = e->ObjectID;
		FormNew(CurrFormID);
		switch(CurrFormID){
		case Form_Form_1000:
			c = FormGetComponentPtr(CheckBtn_CheckBox_1002);
			c->Selected = Hack;
			c = FormGetComponentPtr(CheckBtn_CheckBox_1003);
			c->Selected = Shortcuts;
			FormSetEventHandler(MainFormHandleEvent);
			FormDraw();
			FMDrawString(5, 20, "[Memo]");
			FMDrawString(5, 30, "(Address)");
			FMDrawString(5, 40, "<Scheduler>");
			FMDrawString(5, 50, "`Todo'");
			FMDrawString(5, 60, "{{InkWriter}}");
			FMDrawString(5, 70, "{PhotoAlbum}");
			ret = TRUE;
			break;
		}
		break;
	case FORMUNLOADEVENT:
		FormFree();
		ret = TRUE;
		break;
	}

	return ret;
}

Boolean
MainFormHandleEvent(EventStruct *e)
{
	Boolean	ret = FALSE;
	ComponentStruct	*c, *s;
	EventStruct	event;
	CVHACKINFO	cvhack;
	//MyHackInfo	HackInfo;

	switch(e->EventType){
	case COMPONENTSELECTEVENT:
		c = FormGetComponentPtr(e->ObjectID);
		switch(e->ObjectID){
		case CheckBtn_CheckBox_1002:
			if(!Hack){
				Hack = TRUE;
				CheckBoxSelectOn(c);
				cvhack.pHackName = (P_U8)"wikiZ";
				cvhack.pNote = (P_U8)"wikiZ";
				cvhack.InfoLen = 0;//sizeof(MyHackInfo);
				cvhack.pInfo = NULL;//(P_U8)&HackInfo;
				cvhack.AppID = AppID = GetCurAppID();
				cvhack.OpFlag = 3;
				cvhack.Fn = MyHackFunction;
				SetCVHackFunction(&cvhack);
			}else{
				Hack = FALSE;
				CheckBoxSelectOff(c);
				cvhack.Fn = MyHackFunction;
				GetCVHackInfo(&cvhack);
				RemoveCVHackFunction(&cvhack);
			}
			ret = TRUE;
			break;
		case CheckBtn_CheckBox_1003:
			if(!Shortcuts){
				Shortcuts = TRUE;
				CheckBoxSelectOn(c);
			}else{
				Shortcuts = FALSE;
				CheckBoxSelectOff(c);
			}
			ret = TRUE;
			break;
		}
	case MENUSELECTEVENT:
		switch(e->ObjectID){
		case MenuItem_Item_01_1012:
			/* About */
			mkinfo(ABOUT);
			ret = TRUE;
			break;
		case MenuItem_Item_02_1013:
			/* Exit */
			ChangeToApplication(APPMAN_ID, NORMAL_START, 0);
			ret = TRUE;
			break;
		}
	}

	return ret;
}

Boolean
MyHackFunction(EventStruct *e, P_VOID pInfo)
{
	Boolean	ret = FALSE;
	ComponentStruct	*c;
	ScanId	scanId;
	RecId	recId;
	FlagValue	flag;
	DBMErr	err;
	U8	*buf, *keyword, sep, *p, *q, ipw0, ipw;
	U32	appId0, appId, aid;
	int	i, j, link, tap;
	EventStruct	event;
	//MyHackInfo	*pHackInfo;

	switch(e->EventType){
	case AREATOUCHUPEVENT:
	case PENUPSTSEVENT:
		appId = GetCurAppID();
		if(hDepth >= 0 &&
		  (appId == APPMAN_ID || appId == CELART_ID))
			hDepth = -1;
		break;
	case PENUPEVENT:
		c = FormGetComponentPtr(e->ObjectID);
		if(c->ComponentType != FIELDEDITC)
			break;

		appId = GetCurAppID();
		for(i=0; i<nkbdIds; i++){
			if(appId == kbdId[i])
				break;
		}
		if(i < nkbdIds)
			break;

		buf = c->ComponentData.FieldEditData.Buffer;
		p = c->ComponentData.FieldEditData.Cursor.Pointer;
		q = c->ComponentData.FieldEditData.EndOfSelection;

		if(Shortcuts && p != q){
			if(p > q){
				p = c->ComponentData.FieldEditData.EndOfSelection;
				q = c->ComponentData.FieldEditData.Cursor.Pointer;
			}
			WordLen = q - p + 4;
			Word = (U8 *)Lmalloc(WordLen+1);
			if(!Word){
				mkerror("wikiZ: Memory Exhausted!");
				break;
			}
			memset(Word, 0, WordLen+1);
			strncpy(Word+2, p, q-p);
			RequestToApplication(AppID, REQ_USER_COMMAND, NULL);
			if(iLink < 0){
				Lfree(Word);
				break;
			}
			for(i=0; i<WordLen && !Word[i]; i++);
			for(; i<WordLen && Word[i]; i++)
				EventPutKeyboardEvent(Word[i]);
			Lfree(Word);
			break;
		}
		if(!GetKeyWord(buf, p, &keyword, &sep))
			break;

		for(link=0; link<nTables; link++){
			if(sep == Link[link].sep)
				break;
		}
		if(link == nTables || Link[link].tid == NULL_TABLE_ID){
			Lfree(keyword);
			break;
		}

		if(!FindData(Link[link].tid, Link[link].fid, keyword,
					0, &recId) &&
		   (++link != SchedRpDB ||
		    !FindData(Link[link].tid, Link[link].fid, keyword,
			    0, &recId))){
			Lfree(keyword);
			break;
		}
		Lfree(keyword);

		Cvfs.tableId = Link[link].tid;
		Cvfs.FindRecID = recId;

		err = 0;
		ipw0 = 0;
		for(tap=0; tap<nTables; tap++){
			for(i=0; i<nAids&&Link[tap].aid[i]&&
					appId!=Link[tap].aid[i]; i++);
			if(appId == Link[tap].aid[i]){
				err = 1;
				ipw0 = Link[tap].ipw[i];
				if(Link[tap].tfid != NULL_FIELD_ID){
					if(FindData(Link[tap].tid, Link[tap].tfid, buf, 1, &recId)){
						err = 0;
						Link[tap].aidx = i;
						if(tap == SchedNrDB)
							Link[tap+1].aidx = i;
						else
						if(tap == SchedRpDB)
							Link[tap-1].aidx = i;
						break;
					}
				}
			}
		}

		if(err){
			mkerror("wikiZ: DataBase Error!");
			break;
		}

		aid = Link[link].aid[Link[link].aidx];
		ipw = Link[link].ipw[Link[link].aidx];

		ret = TRUE;
		break;
	case BUTTONUPEVENT:
		switch(e->ObjectID){
		case ENTER_BTN:
			if(hDepth < 0)
				break;
			aid = hInfo[hDepth].aid;
			ipw = hInfo[hDepth].ipw;
			Cvfs.tableId = hInfo[hDepth].tid;
			Cvfs.FindRecID = hInfo[hDepth].rid;
			ret = TRUE;
			break;
		}
		break;
	}

	if(ret){
		if(!ipw){
			if((err=DBMOpenSeqScanTable(Cvfs.tableId, DBM_PRIM, 0,
						DBM_INCR, &scanId)) != DBM_OK){
				SnPrintf(tmp, TMPSIZE,
					"wikiZ: DBMOpenSeqScanTable: %d", err);
				mkerror(tmp);
				return ret;
			}
			if((err=DBMGetRecordStatus(scanId, Cvfs.FindRecID,
						SECRET_FLAG, &flag)) != DBM_OK){
				SnPrintf(tmp, TMPSIZE,
					"wikiZ: DBMGetRecordStatus: %d", err);
				mkerror(tmp);
				DBMCloseScan(scanId);
				return ret;
			}
			DBMCloseScan(scanId);

			if(flag == DBM_ON && !GetSecShowMode()){
				if(IsSecuLockAvailable()){
					if(!GetSecuLockBoxDo())
						return ret;
				}else
				if(GetPasswordStatus()){
					if(!GetPWBoxDo())
						return ret;
				}
			}
		}

		if(e->EventType == PENUPEVENT){
			appId0 = GetOrgAppID();
			if(appId != appId0){
				if(hDepth+1 == HINFOSIZE){
					for(i=0; i<hDepth; i++)
						hInfo[i] = hInfo[i+1];
					hDepth = HINFOSIZE-1;
				}else
					hDepth++;
				hInfo[hDepth].aid = appId0;
				hInfo[hDepth].ipw = 0;
				for(i=0; i<nTables; i++){
					for(j=0; j<nAids&&Link[i].aid[j]&&appId0!=Link[i].aid[j]; j++);
					if(appId0 == Link[i].aid[j]){
						hInfo[hDepth].ipw = Link[i].ipw[j];
						break;
					}
				}
				hInfo[hDepth].tid = NULL_TABLE_ID;
				hInfo[hDepth].rid = NULL_REC_ID;
			}
			if(tap < nTables){
				if(hDepth+1 == HINFOSIZE){
					for(i=0; i<hDepth; i++)
						hInfo[i] = hInfo[i+1];
					hDepth = HINFOSIZE-1;
				}else
					hDepth++;
				hInfo[hDepth].aid = appId;
				hInfo[hDepth].ipw = ipw0;
				if(Link[tap].tfid != NULL_FIELD_ID){
					hInfo[hDepth].tid = Link[tap].tid;
					hInfo[hDepth].rid = recId;
				}else{
					hInfo[hDepth].tid = NULL_TABLE_ID;
					hInfo[hDepth].rid = NULL_REC_ID;
				}
			}else
			if(tap == nTables)
				hDepth = -1;
		}else
			hDepth--;

		if(Cvfs.tableId != NULL_TABLE_ID)
			ChangeToApplication(aid, REQ_VIEWFINDDATA, &Cvfs);
		else
			ChangeToApplication(aid, NORMAL_START, NULL);
	}

	return ret;
}

Boolean
FindData(TableId tableId, FieldId fieldId, U8 *keyword, U8 mode, RecId *recId)
{
	ScanId	scanId;
	FieldDataInfo	fi[NUM_FIELDS];
	FieldData	fd;
	DBMErr	err;
	U8	date[9], *p;
	U16	Y, M, D, h, m, s;
	int	i, j, l, n;

	if(!keyword || !*keyword || !recId)
		return FALSE;

	if(!mode &&
	   (tableId == Link[SchedNrDB].tid ||
	    tableId == Link[SchedRpDB].tid)){
		DateTimeRead(&Y, &M, &D, &h, &m, &s);
		SnPrintf(date, 9, "%04d%02d%02d", Y, M, D);

		if((p=strchr(keyword, '@'))){
			l = p - keyword;
			if(!*(++p))
				p = NULL;
		}else
			l = strlen(keyword);
		n = 0;
		j = 7;
		for(i=l-1; i>=0&&j>=0; i--){
			if(!isdigit(keyword[i]))
				continue;
			if(n<2){
				n++;
				date[j--] = keyword[i];
				i--;
				if(i>=0 && isdigit(keyword[i]))
					date[j--] = keyword[i];
				else
					date[j--] = '0';
			}else
				date[j--] = keyword[i];
		}
		strcpy(tmp, date);
		keyword = p;
		l = (keyword?strlen(keyword):0);
	}else{
		l = strlen(keyword);
		strncpy(tmp, keyword, (l+1 < PATTERN_LEN ? l+1 : PATTERN_LEN));
		tmp[PATTERN_LEN-1] = 0;
	}

	fd.id = fieldId;
	fd.type = DBM_STRING;
	fd.len = strlen(tmp)+1;
	fd.content.str = tmp;

	if((err=DBMOpenSearchScanTable(tableId, DBM_ONE_FIELD, &fd, &scanId))
			!= DBM_OK){
		SnPrintf(tmp, TMPSIZE,
				"wikiZ: DBMOpenSearchScanTable: %d", err);
		mkerror(tmp);
		return FALSE;
	}

	for(; ; ){
		if((err=DBMGetNextRecordId(scanId, recId, &n, fi)) != DBM_OK){
			DBMCloseScan(scanId);
			return FALSE;
		}

		if((err=DBMGetRecordFieldPtr(scanId, *recId, fieldId, &fd))
				!= DBM_OK){
			SnPrintf(tmp, TMPSIZE,
					"wikiZ: DBMGetRecordFieldPtr: %d", err);
			mkerror(tmp);
			DBMCloseScan(scanId);
			return FALSE;
		}
		p = fd.content.str;
		if(!mode &&
		   (tableId == Link[SchedNrDB].tid ||
		    tableId == Link[SchedRpDB].tid)){
			if(strcmp(date, p))
				break;
			if(!keyword){
				DBMCloseScan(scanId);
				return TRUE;
			}
			if((err=DBMGetRecordFieldPtr(scanId, *recId, 3, &fd))
					!= DBM_OK){
				SnPrintf(tmp, TMPSIZE,
					"wikiZ: DBMGetRecordFieldPtr: %d", err);
				mkerror(tmp);
				DBMCloseScan(scanId);
				return FALSE;
			}
			p = fd.content.str;
		}else
		if(!strstr(p, keyword))
			break;
		if(!strncmp(keyword, p, l) &&
		   (!p[l] || (!mode && (p[l] == '\r' || p[l] == '\n')))){
			DBMCloseScan(scanId);
			return TRUE;
		}
	}
	DBMCloseScan(scanId);

	return FALSE;
}

Boolean
GetKeyWord(U8 *buf, U8 *ptr, U8 **keyword, U8 *sep)
{
	int	l;
	U8	*p, *p1, *p2;

	if(!buf || !*buf || !ptr || !*ptr || !keyword || !sep)
		return FALSE;

	*keyword = NULL;
	*sep = 0;

	for(p1=ptr; p1>=buf&&!strchr("[(<`{}'>)]", *p1); p1--);
	if(p1 < buf || strchr("}'>)]", *p1))
		return FALSE;

	for(p2=ptr; *p2&&!strchr("[(<`{}'>)]", *p2); p2++);
	if(!*p2 || p2 == p1+1 || strchr("[(<`{", *p2))
		return FALSE;

	if((*p1 == '[' && *p2 == ']') ||
	   (*p1 == '(' && *p2 == ')') ||
	   (*p1 == '<' && *p2 == '>') ||
	   (*p1 == '`' && *p2 == '\''))
		*sep = *p1;
	else
	if(*p1 == '{' && *p2 == '}'){
		if(p1-1 >= buf && *(p1-1) == '{' && *(p2+1) == '}')
			*sep = '}';
		else
		if((p1-1 < buf || *(p1-1) != '{') && *(p2+1) != '}')
			*sep = '{';
	}else
		return FALSE;

	for(p=p1+1; p<p2&&strchr(" \t\r\n", *p); p++);
	if(p == p2){
		*sep = 0;
		return FALSE;
	}

	l = p2-p1-1;
	*keyword = (U8 *)Lmalloc(l+1);
	if(!*keyword){
		mkerror("wikiZ: Memory Exhausted!");
		*sep = 0;
		return FALSE;
	}
	strncpy(*keyword, p1+1, l);
	(*keyword)[l] = 0;

	return TRUE;
}

Boolean
ShortcutsFormHandleEvent(EventStruct *e)
{
	Boolean	ret = FALSE;

	switch(e->EventType){
	case COMPONENTSELECTEVENT:
		iLink = -1;
		switch(e->ObjectID){
		case PushBtn_PushButton_1005:
			iLink = 0;
			Word[1] = '[';
			Word[WordLen-2] = ']';
			break;
		case PushBtn_PushButton_1006:
			iLink = 1;
			Word[1] = '(';
			Word[WordLen-2] = ')';
			break;
		case PushBtn_PushButton_1007:
			iLink = 2;
			Word[1] = '<';
			Word[WordLen-2] = '>';
			break;
		case PushBtn_PushButton_1008:
			iLink = 3;
			Word[1] = '`';
			Word[WordLen-2] = '\'';
			break;
		case PushBtn_PushButton_1009:
			iLink = 4;
			Word[0] = '{';
			Word[1] = '{';
			Word[WordLen-2] = '}';
			Word[WordLen-1] = '}';
			break;
			break;
		case PushBtn_PushButton_1014:
			iLink = 5;
			Word[1] = '{';
			Word[WordLen-2] = '}';
			break;
		case PushBtn_PushButton_1015:
			iLink = 6;
			Word[0] = 0x19;
			break;
		case PushBtn_PushButton_1016:
			iLink = 7;
			Word[0] = 0x19;
			Word[1] = 0x18;
			Word[2] = 0;
			break;
		}
		EventPutDBoxCloseEvent();
		ret = TRUE;
	}

	return ret;
}

DBoxDrawCallbackFuncPtr
DrawShortcutsForm(void)
{
	FMSetFont(ENG11LITE_HANGUL);
	FMDrawString(80, 22, Word+2);
	return;
}
